# class Crystal::Macros::AsmOperand

- Crystal::Macros::AsmOperand
- Crystal::Macros::ASTNode

##
Overview

An output or input operand for an `Asm` node.

Every operand `node` is equivalent to:

    {{ node.constraint }}({{ node.exp }})

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #constraint : StringLiteral

  Returns the constraint string of this operand.

- #exp : ASTNode

  Returns the associated output or input argument of this operand.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def constraint : StringLiteral #

Returns the constraint string of this operand.

def exp : ASTNode #

Returns the associated output or input argument of this operand.